import greenfoot.*;

public class Guy extends GQActor
{
    private int platformDrag = 2; // added to allow changing value of drag on platforms (Wall objects)
    
    /**
     * most of the set-up for this actor was done in the world constructor; it could just as well
     * have been done in this constructor, but having it done there gives one a better idea of the
     * versitility of the superclass (in that multiple Guy objects can be created using different
     * settings)
     */ 
    public Guy()
    {
        // see GQActor class for what these methods do (view it as documentation)
        setObstacles(Wall.class);
        setImages();
        setJumpImages("person2.png");
    }

    // method for movement control
    public void act()
    {
        moveVertically();
        if (hasGroundChanged()) // added to adjust on ground drag value when needed
        {
            if (getGroundActor() instanceof Wall) setGroundDrag(platformDrag); // drag for platforms
            else setGroundDrag(20); // drag for botton edge of world
        }
        moveHorizontally();
    }
    
    // method added to adjust the current drag value depending on where the actor currently is
    public void setPlatformDrag(int drag)
    {
        platformDrag = drag;
        if (isOnGround() && getGroundActor() instanceof Wall) setGroundDrag(platformDrag);
    }
}